TARGET   = coreaction
TEMPLATE = app

QT      += widgets dbus

VERSION  = 4.2.0

# Library section
unix:!macx: LIBS += -lcprime-widgets
unix:!macx: LIBS += -lcprime-core
unix:!macx: LIBS += -lcsys

# thread - Enable threading support
# silent - Do not print the compilation syntax
CONFIG  += thread silent

# Disable QDebug on Release build
CONFIG(release, debug|release):DEFINES += QT_NO_DEBUG_OUTPUT

# Warn about deprecated features
DEFINES += QT_DEPRECATED_WARNINGS
# Disable all deprecated features before Qt 5.15
DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x051500

# Build section
BUILD_PREFIX = $$(CA_BUILD_DIR)

isEmpty( BUILD_PREFIX ) {
        BUILD_PREFIX = ./build
}

MOC_DIR       = $$BUILD_PREFIX/moc-qt5
OBJECTS_DIR   = $$BUILD_PREFIX/obj-qt5
RCC_DIR	      = $$BUILD_PREFIX/qrc-qt5
UI_DIR        = $$BUILD_PREFIX/uic-qt5

# C++17 Support for Qt5
QMAKE_CXXFLAGS += -std=c++17

unix {
        isEmpty(PREFIX) {
                PREFIX = /usr
        }
        BINDIR = $$PREFIX/bin

        HOME = $$system(echo $HOME)

        DEFINES += VERSION_TEXT=\"\\\"$${VERSION}\\\"\"
        DEFINES += PREFIX_PATH=\"\\\"$${PREFIX}\\\"\"

        target.path = $$BINDIR

        desktop.path = $$PREFIX/share/applications/
        desktop.files = "org.cubocore.CoreAction.desktop"

        autostart.path  = $$HOME/.config/autostart
        autostart.files = "org.cubocore.CoreAction.desktop"

        icons.path = $$PREFIX/share/icons/hicolor/scalable/apps/
        icons.files = org.cubocore.CoreAction.svg

        INSTALLS += target icons desktop
}

FORMS += \
    coreaction.ui

HEADERS += \
    coreaction.h \
    settings.h

SOURCES += \
    coreaction.cpp \
    main.cpp \
    settings.cpp
